#region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=1320412398_emblem-sound.ico
#AutoIt3Wrapper_Outfile=soundchanger mit tray 1.0.exe
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_Res_Fileversion=1.0
#AutoIt3Wrapper_Res_Language=1031
#AutoIt3Wrapper_Res_requestedExecutionLevel=asInvoker
#AutoIt3Wrapper_Run_Tidy=y
#AutoIt3Wrapper_Run_Obfuscator=y
#endregion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <Constants.au3>
#include <Array.au3>
Opt("TrayMenuMode", 3)

Local $reg[1]
Local $devnamen[1]
Local $blase = 1


If @CPUArch = "X64" Then ; wenn x64 dann nimm den 64er regschlssel
	Global $key = "HKEY_LOCAL_MACHINE64\SOFTWARE\Microsoft\Windows\CurrentVersion\MMDevices\Audio\Render"
Else
	Global $key = "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\MMDevices\Audio\Render"
EndIf

For $i = 1 To 20
	Local $var = RegEnumKey($key, $i)
	If @error <> 0 Then ExitLoop
	$devices = RegRead($key & "\" & $var, "DeviceState") ; status des gertes (nutzbar?!?)
	If $devices = 1 Then ; wenn nutzbar dann steht da eine 1, also nimm das mit auf
		$devname = RegRead($key & "\" & $var & "\" & "Properties", "{b3f8fa53-0004-438e-9003-51a46e139bfc},6") ; name des gertes
		_ArrayAdd($reg, $var) ; regschlssel
		_ArrayAdd($devnamen, $devname) ; gertenamen
	EndIf
Next
_ArrayDelete($devnamen, 0)
_ArrayDelete($reg, 0)

$devs = UBound($devnamen)
$hdmi = TrayCreateItem($devnamen[0])
$real = TrayCreateItem($devnamen[1])
If $devs > 2 Then $head = TrayCreateItem($devnamen[2])
TrayCreateItem("")
$noblase = TrayCreateItem("Kein Traytip")
TrayCreateItem("")
$exititem = TrayCreateItem("Beenden")

TraySetState()
TraySetClick(1)


While 1
	$msg = TrayGetMsg()
	Select
		Case $msg = $hdmi
			Run("SetDefaultAudioDevice.exe" & " " & $reg[0] & " " & "communications", "", @SW_HIDE)
			Run("SetDefaultAudioDevice.exe" & " " & $reg[0] & " " & "multimedia", "", @SW_HIDE)
			If $blase = 1 Then TrayTip("Sounddevice", "" & $devnamen[0], 5, 1)
			TrayItemSetState($hdmi, $TRAY_DISABLE)
			TrayItemSetState($real, $TRAY_ENABLE)
			TrayItemSetState($head, $TRAY_ENABLE)
			Sleep(3000)
		Case $msg = $real
			Run("SetDefaultAudioDevice.exe" & " " & $reg[1] & " " & "communications", "", @SW_HIDE)
			Run("SetDefaultAudioDevice.exe" & " " & $reg[1] & " " & "multimedia", "", @SW_HIDE)
			If $blase = 1 Then TrayTip("Sounddevice", "" & $devnamen[1], 5, 1)
			TrayItemSetState($hdmi, $TRAY_ENABLE)
			TrayItemSetState($real, $TRAY_DISABLE)
			TrayItemSetState($head, $TRAY_ENABLE)
			Sleep(3000)
	EndSelect
	If $devs > 2 Then
		Select
			Case $msg = $head
				Run("SetDefaultAudioDevice.exe" & " " & $reg[2] & " " & "communications", "", @SW_HIDE)
				Run("SetDefaultAudioDevice.exe" & " " & $reg[2] & " " & "multimedia", "", @SW_HIDE)
				If $blase = 1 Then TrayTip("Sounddevice", "" & $devnamen[2], 5, 1)
				TrayItemSetState($hdmi, $TRAY_ENABLE)
				TrayItemSetState($real, $TRAY_ENABLE)
				TrayItemSetState($head, $TRAY_DISABLE)
				Sleep(3000)
		EndSelect
	EndIf
	Select
		Case $msg = $noblase
			If $blase = 1 Then
				$blase = 0
			Else
				$blase = 1
				TrayTip("", "Traytips werden wieder angezeigt", 5, 1)
			EndIf
		Case $msg = $exititem
			ExitLoop
	EndSelect
WEnd
